#include <windows.h>
#include <tchar.h>
#include "resource.h"

#define UM_KEY_IN_CONTROL  ( WM_APP + 1 )
#define MAX_LINE 100


WNDPROC oldProc;
HINSTANCE g_hInst;

// wParam je kd klvesy, lParam je ID prvku
#define UM_KEY_IN_CONTROL  ( WM_APP + 1 )

LRESULT CALLBACK WindowProcEdit(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch ( uMsg )
	{
		case WM_GETDLGCODE:
			return DLGC_WANTALLKEYS;
		case WM_KEYDOWN:
			SendMessage(GetParent(hWnd), UM_KEY_IN_CONTROL,
				wParam /*kod klvesy*/, (LPARAM)GetMenu(hWnd));
			break;
	}
	return CallWindowProc(oldProc, hWnd, uMsg, wParam, lParam);
}

INT_PTR CALLBACK DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	TCHAR chText[MAX_LINE];
	TCHAR newLine[] = {0x0D, 0x0A, 0};
	switch ( uMsg )
	{
		case UM_KEY_IN_CONTROL:
			switch (lParam)
			{
				case IDC_EDIT1:
				case IDC_EDIT2:
					if ( wParam == VK_RETURN )
					{
						GetDlgItemText(hWnd, lParam, chText, MAX_LINE);
						lstrcat(chText, newLine);
						SendDlgItemMessage(hWnd, IDC_EDIT_MULTI, EM_REPLACESEL, FALSE,
							(LPARAM)chText);
					}
					break;
			}
			break;
		case WM_INITDIALOG:
			SetClassLongPtr(hWnd, GCLP_HICONSM,	
				(LONG_PTR)LoadIcon(g_hInst, MAKEINTRESOURCE(IDI_ICON_MAIN)));
			oldProc = (WNDPROC)SetWindowLongPtr(GetDlgItem(hWnd, IDC_EDIT1),
				GWLP_WNDPROC, (LONG_PTR)WindowProcEdit);
			oldProc = (WNDPROC)SetWindowLongPtr(GetDlgItem(hWnd, IDC_EDIT2),
				GWLP_WNDPROC, (LONG_PTR)WindowProcEdit);
			break;
		case WM_COMMAND:
			switch ( LOWORD(wParam) )
			{
				case IDCANCEL:
				case IDOK:
					SetWindowLongPtr(GetDlgItem(hWnd, IDC_EDIT1),
						GWLP_WNDPROC, (LONG_PTR)oldProc);
					SetWindowLongPtr(GetDlgItem(hWnd, IDC_EDIT2),
						GWLP_WNDPROC, (LONG_PTR)oldProc);
					EndDialog(hWnd, LOWORD(wParam));
					break;
			}
			break;
	}
	return FALSE;
}

int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
	LPTSTR lpCmdLine, int nCmdShow)
{
	g_hInst = hInstance;
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG_MAIN), NULL,
		(DLGPROC)DialogProc);
	return 0;
}